/* This code is copyright (c) 2000, John Hansen, W2FS.  It is not public domain
nor is it shareware.  Licensed amateur radio operators are hereby permitted to 
burn one copy of this code for their own personal use.  Note: permission is 
explicitly NOT granted for you to burn chips containing this code for others.
For information on obtaining the commercial rights to this code contact the 
author at john@hansen.net

Ver 2.0

**** Modifiche apportate Giugno 2009:
-Aggiunta funzione Calibrate per le verifiche hardware
-Adattamento del codice per il PIC 16F877A
-Correzione delle temporizzazioni 
-Trasmissione beacon APRS non compresso

*/ 

#include <kiss_a.h>
#include <string.h>   // string.h is part of the CCS C package
#include <terminal_a.h>


int fcslo,fcshi,crclo,crchi,xcrclo,xcrchi;  //fcs is received value, crc is computed value
int ones,test;
int txlimit,txtimes;
int rreadaddC,rreadaddA,rreadaddE; //addresses for storing received data (bitin and kissout)
int rwriteaddC,rwriteaddA,rwriteaddE;
int XreadaddC,xreadaddA,xreadaddE; //addresses for reading data to be transmitted (xmitok)
int XwriteaddC,XwriteaddA,XwriteaddE; //addresses for writing data to be transmitted (incoming)
int c0xmit,C0rcv,txdelay;
int stuff,beacon,opmode;
short crcflag,flag,C0;
long txcount;

byte messbyte;
byte dest[28];
byte indata[12];
byte timestamp[6];
byte latit[7];
byte ns;
byte longit[8];
byte ew;
byte speed[5];
byte course[5];

void setbaudrate(){
int i;

    i = read_eeprom(80);
    switch(i){
        case 0x31 : set_uart_speed(1200);break;  //set the baudrate on the RS232 port
        case 0x32 : set_uart_speed(2400);break;
        case 0x33 : set_uart_speed(4800);break;
        case 0x34 : set_uart_speed(9600);break;
        case 0x35 : set_uart_speed(19200);break;
        default : set_uart_speed(9600);
    }
}




void IncRReadAdd(){   //increments the received data space address
    rreadaddC++;
    if (rreadaddC == 0b01000000){ //rolls over A
             rreadaddA++; 
             rreadaddC = 0x00;
    }
}

void IncRWriteAdd(){   //increments the received data space address
    rwriteaddC++;
    if (rwriteaddC == 0b01000000){ //rolls over A
             rwriteaddA++; 
             rwriteaddC = 0x00;
    }
}

        
void IncXWriteAdd(){  //increments the transmit data space address for writing data
    XwriteaddC++;
    if (XwriteaddC == 0b01000000){  //rolls over A
            XwriteaddA++;
            XwriteaddC = 0x00;
    }
    if (XwriteaddA == 0b01000000){  //rolls over E
            XwriteaddE++;
            XwriteaddA = 0x00;
    }
    if (XwriteaddE == 0b1000) {  //rolls over to beginning of xmit section of SRAM
            XwriteaddC = XwriteaddA = 0x00;
            XwriteaddE = 0x01;
    }
}
        
void IncXReadAdd(){   //increments the transmit data space address for reading data
    XreadaddC++;
    if (XreadaddC == 0b01000000){  //rolls over A
            XreadaddA++;
            XreadaddC = 0x00;
    }
    if (XreadaddA == 0b01000000){  //rolls over E
            XreadaddE++;
            XreadaddA = 0x00;
    }
    if (XreadaddE == 0b1000) {  //rolls over to beginning of xmit section of SRAM
            XreadaddC = XreadaddA = 0x00;
            XreadaddE = 0x01;
    }
}
void rcvwrite(int byt){   //write a byte to the receive data space

    set_tris_d(0x00); //set data lines to output
    port_d = byt;   //put the data to write on the data lines
    port_c = rwriteaddC;
    port_a = rwriteaddA;  //put the address on the address lines
    port_e = 0x00;
    output_low(WE);
    output_low(CS);   //writes the address
    output_high(CS);  //writes the data
    output_high(WE);
    IncRWriteAdd();
}

int rcvread(){  //read a byte from the receive data space
int inbyte;

    set_tris_d(0xff); //set data lines to input
    port_c = rreadaddC;
    port_a = rreadaddA;  //put the address on the address lines
    port_e = 0x00;
    output_low(CS);
    inbyte = port_d;
    output_high(cs);
    IncRReadAdd();
    return inbyte;

}

void xwrite(int byt){  //write a byte to the transmit data space

    set_tris_d(0x00); //set data lines to output
    port_d = byt;   //put the data to write on the data lines
    port_c = XwriteaddC;
    port_a = XwriteaddA;  //put the address on the address lines
    port_e = XwriteaddE;
    output_low(WE);
    output_low(CS);   //writes the address
    output_high(CS);  //writes the data
    output_high(WE);
    IncXwriteAdd();
}

int xread(){ //read a byte from the transmit data space
int inbyte;

    set_tris_d(0xff);  //set data lines to input
    port_c = XreadaddC;
    port_a = XreadaddA;  //put the address on the address lines
    port_e = XreadaddE;
    output_low(CS);
    inbyte = port_d;
    output_high(cs);
    IncXreadAdd();
    return inbyte;
}

int outgoing(){
int inbyte;

    if (C0rcv >0){
        
         if (bit_test(pir1,4)){
            inbyte = rcvread();
            if (inbyte == 0xC0){
                (c0rcv--);
                if (opmode == 0x31) (putc(inbyte));
            }
               else (putc(inbyte));
            return 1;
        }
    }
    return 0;
}
int incoming(){  //process incoming characters from the serial port
int inbyt; 

    if (bit_test(pir1,5)){  //if there is a byte in the buffer
         inbyt = getc();  //get the incoming byte
         if (inbyt == 0xC0) {
                xwrite(inbyt);
      C0 = (C0^1);//  flip C0;
                (c0xmit++);   //c0xmit/2 is the number of completed packets in the buffer.
         }
         else{       
             if (C0==TRUE) (xwrite(inbyt));  //write the byte if in the middle of a kiss frame or if the byte is a C0
         }
           return 1;
     }//end of if
    return 0;
}
       

void flipout(){         //flips the output state
   stuff = 0;
   if (!bit_test(port_b,1)) (output_high(txd));
      else (output_low(txd));
}


void crcbit(byte tbyte){
#asm
   BCF    03,0
   RRF    xcrchi,F    //rotates the entire 16 bits to the right
   RRF    xcrclo,F
#endasm
   if (((status & 0x01)^(tbyte)) ==0x01){
         xcrchi = xcrchi^0x84;
         xcrclo = xcrclo^0x08;
   }
 }


void sendbyte (byte inbyte){
   int k,bt;
   for (k=0;k<8;k++){
     bt = inbyte & 0x01;       //strip off the rightmost bit
     if ((!crcflag) && (!flag)) (crcbit(bt));   //do crc, but only if this is not a flag or crc byte
     if (!bt) (flipout());  // if this bit is a zero, flip the output state
        else {
            stuff++;    //increment 1's count
            if ((!flag) && (stuff == 5)){   //stuff an extra 0, if 5 1's in a row
         outgoing();
         if (incoming()==0) (delay_cycles(17));
              if (k==7) (delay_us(581));else delay_us(686);delay_cycles(257);
              flipout();
            }
        }
     #asm
        rrf   inbyte,F
     #endasm
      outgoing();
      if (incoming()==0) (delay_cycles(17));
       if (k==7) (delay_us(581));else delay_us(686);delay_cycles(257);
  }
}



void xmitok(){     //transmit the KISS data over radio
int c,outbyte;
short DB;
int i;

While (c0xmit/2 > 0x00){   //do this if there is any data to transmit
   xcrclo=xcrchi=0xFF;
   stuff = 0;
   flag = TRUE;
   crcflag = FALSE;

   txdelay = read_eeprom(0); // read txdelay from eeprom.
   outbyte = xread(); //reads the C0 byte 
   outbyte = xread(); //reads the next byte (00 if it's data);

   if (outbyte == 0) {  //only transmit if this is a data packet
       output_high(PTT);
       output_high(m0);  //set up the MX614 to transmit
   }
   outbyte = xread(); //reads the first address byte.
   for (c=0;c<txdelay;c++) (sendbyte(0));//send nulls
   sendbyte(0x7E); //send flag      //each byte takes approx 6.7 ms
//   sendbyte(0x7E);
   flag = FALSE;
   i=0;
   While (outbyte != 0xC0){
      switch (outbyte){
               case 0xDB : db = TRUE; break;
               case 0xDC : if (db == TRUE){
                                sendbyte(0xC0); 
                                db = FALSE;
                            } // end of if
                                else sendbyte(0xDC);
                                break;
               case 0xDD : if (db == TRUE){
                                sendbyte(0xDB);
                                db = FALSE;
                            }//end of if
                                else sendbyte(0xDD);
                                break;
               default  : sendbyte(outbyte);
            }//end of switch

       outbyte = xread();
       i++;
   }//end of while
   crcflag = TRUE;
   xcrclo = xcrclo^0xff;
   xcrchi = xcrchi^0xff;
   sendbyte(xcrclo); //send the low byte of crc
   sendbyte(xcrchi); //send the high byte of crc
   FLAG = TRUE;
   sendbyte(0x7e); //sendbyte(0x7e);     // Send flags to end packet
   c0xmit = c0xmit - 2; // decrement the number of frames waiting.
 }//end of while c0xmit/2

   output_low(PTT); //unkey PTT
   output_low(txd);
   output_low(M0);  //MX 614 to recv mode
}


int bitin(){  //function to read a bit from the radio link
static int oldstate;  //oldstate retained between runs of this function
int k,l;

    l=0;
    if (outgoing()) (l=l+2);
    if (incoming()) (l=l+2);
   for (k=l;k<130;k++){ //this loop allows 838 us to go by.  If no state change in this time, bit is 1
        if (input(rxd) != oldstate){    //state has changed
            oldstate = input(rxd);  //update oldstate
               delay_us(375);  // move to halfway thru the next bit. note timing resynchs on each 0.
            return 0;  //return 0 if state changed
         }//end of if
      }//end of for
   return 1;  //return 1 if state did not change
}//end of bitin()


int getbyte(){   //get a byte from the radio link
int rbyte,rbit,s;

   rbyte =0;
   for(s=0;s<8;s++){
         rbit = bitin(); //get a bit
         if (rbit == 1) (ones++);   //increment the ones counter
            else (ones =0);   
         if (ones == 5) {  //removes bit stuffing
            test = bitin();  //get the next bit (a zero) and discard it
            if (test == 1) (s++);
            ones = 0; //reset the ones counter
         }
         shift_right(&rbyte,1,rbit);
      }//end of for
   return rbyte;

}


void addcrc(int crbyte){  //ongoing computation of received CRC
int k,bt;

   for(k=0;k<8;k++){
      bt = crbyte & 0x01;   
      #asm
           BCF    03,0
            RRF    crchi,F    //rotates the entire 16 bits to the right
            RRF    crclo,F
      #endasm
         if (((status & 0x01)^(bt)) ==0x01){
                 crchi = crchi^0x84;
                 crclo = crclo^0x08;
           }
      rotate_right(&crbyte,1);  //can reduce this by using assembler
   }
}
#INLINE   //to improve speed;
void kisswrite(int inbyte){

   switch (inbyte){
        case 0xC0: rcvwrite(0xDB);rcvwrite(0xDC);break;   //Kiss substitutions
        case 0xDB: rcvwrite(0xDB);rcvwrite(0xDD);break;   //Kiss substitutions
        default: rcvwrite(inbyte);  //else save the byte to SRAM
   }
}





void readvariable(){       //read the variable up to the next comma into indata[]
int i, k;

   i=0;
   for(k=0;k<12;k++) (indata[i]=0);
   do {
      indata[i] = getc();
      i++;
   }while ((indata[i-1] != 0x2c) & (i <12));
}


int getdest(){
   int k;

    if (read_eeprom(2) == 0x40){   //check to see if destination is null, if so set last callsign1 bit to 1
           dest[0] = 0x82; // char 'A'
           dest[1] = 0xA0; // char 'P'
           dest[2] = 0xA4; // char 'R'
           dest[3] = 0xA6; // char 'S'
           dest[4] = 0x40; // space
           dest[5] = 0x40; // space
           dest[6] = 0x60; // ssid = 0
           for (k=9;k<16;k++) (dest[k-2] = read_eeprom(k));
           dest[13]++;
           return 14;
    }
    else if (read_eeprom(16) == 0x40){ //same for digi1
           for (k=2;k<16;k++) (dest[k-2] = read_eeprom(k));
           dest[13]++;
           return 14;
    }
    else if (read_eeprom(23) == 0x40){ //same for digi2
           for (k=2;k<23;k++) (dest[k-2] = read_eeprom(k));
           dest[20]++;
           return 21;
    }
    else {
           for (k=2;k<30;k++) (dest[k-2] = read_eeprom(k));
           dest[27]++;
           return 28;
    }

}


void getposition(){
int k;

//following gets latitude, longitude, etc.
  
     start1:  while (indata[0] != 'G')(indata[0]=getc());   //finds the GPRMC sentence

            indata[0] = getc();
            if (indata[0] != 'P'){
               goto start1;
            }
            indata[0] = getc();
            if (indata[0] != 'R'){
               goto start1;
            }
             indata[0] = getc();
            if (indata[0] != 'M'){
               goto start1;
            }
            indata[0] = getc();
            if (indata[0] != 'C'){
               goto start1;
            }
            (indata[0]=getc()); //grab the comma

     readvariable();
       for(k=0;k<6;k++) (timestamp[k] = indata[k]);
     readvariable();
//     if (indata[0] != 'A') {
//     goto start1;
//     }
     readvariable();
      for(k=0;k<7;k++) (latit[k] = indata[k]);
     readvariable();
      ns = indata[0];
     readvariable();
      for(k=0;k<8;k++) (longit[k] = indata[k]);
     readvariable();
      ew = indata[0];
     readvariable();
      speed[0] = speed[1] = speed[2] = 0; k = 5;
      do{
      k--;
      }while (indata[K] != 0x2e);
      if(k>2) {
      speed[0] = indata[k-3];
      speed[1] = indata[k-2];
      speed[2] = indata[k-1];
      } else if(k==2) {
      speed[0] = 0x30;
      speed[1] = indata[k-2];
      speed[2] = indata[k-1];
      } else if(k==1) {
      speed[0] = 0x30;
      speed[1] = 0x30;
      speed[2] = indata[k-1];
      }
      
     readvariable();
      course[0] = course[1] = course[2] = 0; k = 5;
      do{
      k--;
      }while (indata[K] != 0x2e);
      if(k>2) {
      course[0] = indata[k-3];
      course[1] = indata[k-2];
      course[2] = indata[k-1];
      } else if(k==2) {
      course[0] = 0x30;
      course[1] = indata[k-2];
      course[2] = indata[k-1];
      } else if(k==1) {
      course[0] = 0x30;
      course[1] = 0x30;
      course[2] = indata[k-1];
      }
}

void sendpacket(void){  //transmits the APRS data
int i,k;
   k = getdest();
   xcrclo=xcrchi=0xFF;
   stuff = 0;
   output_high(PTT);
   output_high(m0); //xmit mode on 614
   flag = TRUE;
   crcflag = FALSE;
   messbyte = read_eeprom(0);                   // legge txdelay
   for (i=0;i<messbyte;i++)(sendbyte(0x00));   //adjust length for txdelay
                                                   //each byte takes approx 6.7 ms
   sendbyte(0x7E);
   flag = FALSE;
      i = getdest();
   for (i=0;i<k;i++) (sendbyte(dest[i]));
   sendbyte(0x03);                          //send control byte
   sendbyte(0xF0);                          // send PID
   sendbyte(0x40);
   for(i=0;i<6;i++) (sendbyte(timestamp[i]));    //send timestamp
   sendbyte(0x7A);
   for(i=0;i<7;i++) (sendbyte(latit[i]));    //send latitude
   sendbyte(ns);
   sendbyte(read_eeprom(30));                 //1st icon char
   for(i=0;i<8;i++) (sendbyte(longit[i]));    //send longitude
   sendbyte(ew);
   sendbyte(read_eeprom(31));                 //2nd icon char
   for(i=0;i<3;i++) (sendbyte(course[i]));    //send course
   sendbyte(0x2F);
   for(i=0;i<3;i++) (sendbyte(speed[i]));    //send speed
   beacon--;
   if (beacon < 1){      //send the message text now and then
        i=36;            //location of beginning of message section
        messbyte = read_eeprom(i);
        i++;
        While (messbyte != 0x00){
            sendbyte(messbyte);
            messbyte = read_eeprom(i);
            i++;
        }
        beacon = read_eeprom(33); 
   }
   crcflag = TRUE;
   xcrclo = xcrclo^0xff;
   xcrchi = xcrchi^0xff;
   sendbyte(xcrclo); //send the low byte of crc
   sendbyte(xcrchi); //send the high byte of crc

   FLAG = TRUE;
   sendbyte(0x7e);sendbyte(0x7e);           // Send flags to end packet
   output_low(PTT);     //unkey PTT
   output_low(txd);
   output_low(M0);  //MX 614 to recv mode
}


void aprsxmit(){   //APRS transmit routine
//   int qtime,i;
      set_uart_speed(4800);
      getposition();
//      qtime = read_eeprom(34);
//      for (i=0;i<qtime;i++) (delay_ms(1000)); //quiettime delay
      sendpacket();  //transmit the packet
      setbaudrate();
}

void main(){
int i,newbit,cbyte,addcount,call;
int addrA,addrC,addrE;
short goodpkt,addflag;

    set_tris_a(0b00000); //address lines outputs
    set_tris_b(0b00001001); //1 = input, 0 = output
    set_tris_c(0b10000000); //rx232 rcv input, address lines output
    set_tris_e(0x00);//address lines output

    output_high(m0);
    output_low(m0);  //mx614 in rcv mode
    output_low(PTT);
    output_high(LED);   //turn LED off
    output_high(we);
    output_high(CS);

    XreadaddC = XwriteaddC =0x00;      //initialize the XMIT SRAM address
    xreadaddA = XwriteaddA = 0x00;  //starts at 4096
    xreadaddE = XwriteaddE = 0x01;
    rreadaddC = rreadaddA = rreadaddE = rwriteaddC = rwriteaddA = rwriteaddE = 0x00;  //initialize the RCV SRAM address.  Start at 0. 
    C0xmit = C0rcv = 0x00;
    C0 = false;
    setbaudrate();
    if (!input(Term)) (Terminal());
    opmode = read_eeprom(1);
    txlimit = read_eeprom(32);  //set time between aprs beacons
    
    txcount = 0;
    beacon = 1;
    cbyte = 0;
    While (TRUE){
        outgoing();
        if (opmode == 0x31) (xmitok());
        if (txtimes >= txlimit){
             txcount = txtimes= 0;
             if ((read_eeprom(32) >0) & (opmode == 0x32))  (aprsxmit());
        }
        while (cbyte != 0x7E){
          shift_right(&cbyte,1,bitin());  //add a new bit to the left of cbyte, discard right bit  -- can reduce this by using ASM
          txcount++;
        }  //end of while
         
   if (txcount >= 11800){   //this generates a wait to transmit period of 10 seconds
      txtimes++;
      txcount = 0;
   }
        output_low(led);  //if a flag, turn on DCD light
  
      do{
   
      While (cbyte == 0x7e){   //find the other flags, if any
             for(i=0;i<8;i++){  
          newbit = bitin();             
          shift_right(&cbyte,1,newbit); //add a new bit to the left of cbyte, discard right bit-- can reduce this by using ASM
            }//end of for
    }//end of while  -- now at end of all the flags - first data byte in cbyte

        addflag = TRUE; // initialize flag for UIoutput
        addrA = rwriteaddA;  //remember the current SRAM address in case 
        addrC = rwriteaddC;  // the FCS doesn't check.
        addrE = rwriteaddE;

        test =  ones = 0; //initialize variables
        crclo=crchi=0xFF;  //initial crc calculation bytes

        rcvwrite(0xC0); //start of frame
        if (opmode == 0x31) (rcvwrite(0x00)); //this is data.
        fcslo = fcshi;fcshi=cbyte; //get the second byte and bump the history list
        cbyte = getbyte();

        addcount = 0;call = 0;
        while (test != 1){    //this will get the rest of the bytes. stop when you get to a flag
            fcslo = fcshi;fcshi=cbyte; //maintain history of previous 2 bytes
            cbyte = getbyte();
            txcount = txcount + 8;
            if (test != 1){
                if (opmode == 0x31){      // Do this if KISS Mode
                    addcrc(fcslo);        // calculate the CRC for the byte 2 bytes ago.
                    kisswrite(fcslo);     // stops 2 bytes before flag to leave fcs in
                }                         // proper bytes and not calculate crc on fcs
                if (opmode == 0x32){      // format for UI frame.
                    addcrc(fcslo);
                    if (addflag){
                       addcount++;

                       if (addcount == 1){
                           if (call == 0){
                              rcvwrite('T');rcvwrite('o');rcvwrite(':');rcvwrite(' ');
                           }
                           if (call == 1){
                               rcvwrite(' ');rcvwrite(' ');rcvwrite('F');rcvwrite('r');rcvwrite('o');rcvwrite('m');
                               rcvwrite(':');rcvwrite(' ');
                           }
                           if (call == 2){
                              rcvwrite('v');rcvwrite(' ');
                           }
                        }//end of if addcount
                       
                       if (addcount < 7){
                          if (fcslo != 0x40) (rcvwrite(fcslo>>1));
                        }else{
                            addcount = 0;call++;
                            newbit = (fcslo>>1) & 0b111111;
                            if (newbit != 0x30){  //write SSID if not 0
                                rcvwrite('-');
                                switch (newbit) {
                                    case 0x3A : rcvwrite('1');rcvwrite('0');break;
                                    case 0x3B : rcvwrite('1');rcvwrite('1');break;
                                    case 0x3C : rcvwrite('1');rcvwrite('2');break;
                                    case 0x3D : rcvwrite('1');rcvwrite('3');break;
                                    case 0x3E : rcvwrite('1');rcvwrite('4');break;
                                    case 0x3F : rcvwrite('1');rcvwrite('5');break;
                                    default   : rcvwrite(newbit);
                                }
                              }
                            rcvwrite(' ');
                        }//end of else
                    }//end of if addflag
                       else (rcvwrite(fcslo));

                    if ((fcslo & 1) & (addflag)){
                         rcvwrite(0x0D);
                         rcvwrite(0x0A);
                         addflag = FALSE;
                         fcslo = fcshi;fcshi=cbyte;
                         cbyte = getbyte();          //get two more bytes and throw them away
                         addcrc(fcslo);              //(PID and Control bytes
                         fcslo = fcshi;fcshi=cbyte;   
                         cbyte = getbyte();
                         addcrc(fcslo);
                    }// end of if fcslo & 1
                 
                }//end of if opmode == 0x32
            }//end of if test != 1 
       
       }//end of while
         if (opmode == 0x32){
             rcvwrite(0x0D);rcvwrite(0x0A);rcvwrite(0x0D);rcvwrite(0x0A);   
          }
        rcvwrite(0xC0);  //C0 to end frame.
       crclo = crclo^0xff;
    crchi = crchi^0xff; //finish crc calculation based on received data
   goodpkt = FALSE; // unless CRC checks, goodpkt is false
        if ((fcslo == crclo) && (fcshi == crchi)) {
       (C0rcv=c0rcv+2);  //packet is good, increment # of packets
       cbyte = 0x7e;     //if the end of the packet, the current byte is a flag
       Goodpkt = TRUE;   //another packet might be coming right along after one flag
   }//end of if
      }while (Goodpkt == TRUE);
      rwriteaddA = addrA;
      rwriteaddC = addrC; //if CRC doesn't check, reset address to beginning
      rwriteaddE = addrE;
      output_high(led); //  turn off dcd light
    }//end of while true

}//end of main

